# Project64 - Nintendo 64 Emulator

Project64 is a free and open-source emulator for the Nintendo 64 and 64DD written in C++.

The emulator is easy to use and includes powerful features for developers, ROM hackers, and more.

## System Requirements

* Operating System
  * Windows XP/Vista/7/8/10
* CPU
  * Intel or AMD processor with SSE2 support
* RAM
  * 512MB or more
* Graphics card
  * DirectX 8 capable (Jabo's Direct3D8)
  * OpenGL 1.1 capable (Project64 Video)
  * OpenGL 3.3 capable (GLideN64)

## How to use

<sub>(Games not included - do **NOT** ask for ROMs.)</sub>

### Stable Builds

Installer for the latest stable release: https://www.pj64-emu.com/download/project64-latest

Follow the instructions in the setup window to complete the installation.

### Development Builds

Development Builds are based off the latest source at GitHub. This allows you to use the latest changes straight away, though these changes may not be fully tested and have issues.

Official buildbot: https://www.pj64-emu.com/nightly-builds

AppVeyor (Windows x86/x64): [![Build status](https://ci.appveyor.com/api/projects/status/sbtwyhaexslyhgx3?svg=true
)](https://ci.appveyor.com/project/project64/project64/branch/master)

<sub>Note: x64 builds are **NOT** recommended for regular use. They are incomplete and very experimental. Due to this, x64 builds are currently _slower_ than 32-bit builds.</sub>

## Support

[**Join the official Project64 Discord Server**](https://discord.gg/Cg3zquF) to report any bugs/issues and seek help from Project64 developers, contributors and the community.

## License

Project64 is licensed under the
[GNU General Public License v2.0](https://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html).
